# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = ['AppsDeploymentArgs', 'AppsDeployment']

@pulumi.input_type
class AppsDeploymentArgs:
    def __init__(__self__, *,
                 app_id: Optional[pulumi.Input[str]] = None,
                 force_build: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a AppsDeployment resource.
        :param pulumi.Input[str] app_id: The app ID
        """
        if app_id is not None:
            pulumi.set(__self__, "app_id", app_id)
        if force_build is not None:
            pulumi.set(__self__, "force_build", force_build)

    @property
    @pulumi.getter(name="appId")
    def app_id(self) -> Optional[pulumi.Input[str]]:
        """
        The app ID
        """
        return pulumi.get(self, "app_id")

    @app_id.setter
    def app_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "app_id", value)

    @property
    @pulumi.getter(name="forceBuild")
    def force_build(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "force_build")

    @force_build.setter
    def force_build(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "force_build", value)


class AppsDeployment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_id: Optional[pulumi.Input[str]] = None,
                 force_build: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        Create a AppsDeployment resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_id: The app ID
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[AppsDeploymentArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a AppsDeployment resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param AppsDeploymentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppsDeploymentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_id: Optional[pulumi.Input[str]] = None,
                 force_build: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppsDeploymentArgs.__new__(AppsDeploymentArgs)

            __props__.__dict__["app_id"] = app_id
            __props__.__dict__["force_build"] = force_build
            __props__.__dict__["deployment"] = None
        super(AppsDeployment, __self__).__init__(
            'digitalocean-native:apps/v2:AppsDeployment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'AppsDeployment':
        """
        Get an existing AppsDeployment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = AppsDeploymentArgs.__new__(AppsDeploymentArgs)

        __props__.__dict__["deployment"] = None
        __props__.__dict__["force_build"] = None
        return AppsDeployment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def deployment(self) -> pulumi.Output[Optional['outputs.AppsDeployment']]:
        return pulumi.get(self, "deployment")

    @property
    @pulumi.getter(name="forceBuild")
    def force_build(self) -> pulumi.Output[Optional[bool]]:
        return pulumi.get(self, "force_build")

