# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'Balance',
    'BillingHistory',
    'InvoicePreview',
    'ListBillingHistoryItems',
    'ListInvoicesItems',
    'MetaMeta',
    'MetaProperties',
    'PageLinks',
    'PageLinksPagesProperties',
]

@pulumi.output_type
class Balance(dict):
    def __init__(__self__, *,
                 account_balance: Optional[str] = None,
                 generated_at: Optional[str] = None,
                 month_to_date_balance: Optional[str] = None,
                 month_to_date_usage: Optional[str] = None):
        """
        :param str account_balance: Current balance of the customer's most recent billing activity.  Does not reflect `month_to_date_usage`.
        :param str generated_at: The time at which balances were most recently generated.
        :param str month_to_date_balance: Balance as of the `generated_at` time.  This value includes the `account_balance` and `month_to_date_usage`.
        :param str month_to_date_usage: Amount used in the current billing period as of the `generated_at` time.
        """
        if account_balance is not None:
            pulumi.set(__self__, "account_balance", account_balance)
        if generated_at is not None:
            pulumi.set(__self__, "generated_at", generated_at)
        if month_to_date_balance is not None:
            pulumi.set(__self__, "month_to_date_balance", month_to_date_balance)
        if month_to_date_usage is not None:
            pulumi.set(__self__, "month_to_date_usage", month_to_date_usage)

    @property
    @pulumi.getter(name="accountBalance")
    def account_balance(self) -> Optional[str]:
        """
        Current balance of the customer's most recent billing activity.  Does not reflect `month_to_date_usage`.
        """
        return pulumi.get(self, "account_balance")

    @property
    @pulumi.getter(name="generatedAt")
    def generated_at(self) -> Optional[str]:
        """
        The time at which balances were most recently generated.
        """
        return pulumi.get(self, "generated_at")

    @property
    @pulumi.getter(name="monthToDateBalance")
    def month_to_date_balance(self) -> Optional[str]:
        """
        Balance as of the `generated_at` time.  This value includes the `account_balance` and `month_to_date_usage`.
        """
        return pulumi.get(self, "month_to_date_balance")

    @property
    @pulumi.getter(name="monthToDateUsage")
    def month_to_date_usage(self) -> Optional[str]:
        """
        Amount used in the current billing period as of the `generated_at` time.
        """
        return pulumi.get(self, "month_to_date_usage")


@pulumi.output_type
class BillingHistory(dict):
    def __init__(__self__, *,
                 amount: Optional[str] = None,
                 date: Optional[str] = None,
                 description: Optional[str] = None,
                 invoice_id: Optional[str] = None,
                 invoice_uuid: Optional[str] = None,
                 type: Optional['BillingHistoryType'] = None):
        """
        :param str amount: Amount of the billing history entry.
        :param str date: Time the billing history entry occurred.
        :param str description: Description of the billing history entry.
        :param str invoice_id: ID of the invoice associated with the billing history entry, if  applicable.
        :param str invoice_uuid: UUID of the invoice associated with the billing history entry, if  applicable.
        :param 'BillingHistoryType' type: Type of billing history entry.
        """
        if amount is not None:
            pulumi.set(__self__, "amount", amount)
        if date is not None:
            pulumi.set(__self__, "date", date)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if invoice_id is not None:
            pulumi.set(__self__, "invoice_id", invoice_id)
        if invoice_uuid is not None:
            pulumi.set(__self__, "invoice_uuid", invoice_uuid)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def amount(self) -> Optional[str]:
        """
        Amount of the billing history entry.
        """
        return pulumi.get(self, "amount")

    @property
    @pulumi.getter
    def date(self) -> Optional[str]:
        """
        Time the billing history entry occurred.
        """
        return pulumi.get(self, "date")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description of the billing history entry.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="invoiceId")
    def invoice_id(self) -> Optional[str]:
        """
        ID of the invoice associated with the billing history entry, if  applicable.
        """
        return pulumi.get(self, "invoice_id")

    @property
    @pulumi.getter(name="invoiceUuid")
    def invoice_uuid(self) -> Optional[str]:
        """
        UUID of the invoice associated with the billing history entry, if  applicable.
        """
        return pulumi.get(self, "invoice_uuid")

    @property
    @pulumi.getter
    def type(self) -> Optional['BillingHistoryType']:
        """
        Type of billing history entry.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class InvoicePreview(dict):
    """
    The invoice preview.
    """
    def __init__(__self__, *,
                 amount: Optional[str] = None,
                 invoice_period: Optional[str] = None,
                 invoice_uuid: Optional[str] = None,
                 updated_at: Optional[str] = None):
        """
        The invoice preview.
        :param str amount: Total amount of the invoice, in USD.  This will reflect month-to-date usage in the invoice preview.
        :param str invoice_period: Billing period of usage for which the invoice is issued, in `YYYY-MM`  format.
        :param str invoice_uuid: The UUID of the invoice. The canonical reference for the invoice.
        :param str updated_at: Time the invoice was last updated.  This is only included with the invoice preview.
        """
        if amount is not None:
            pulumi.set(__self__, "amount", amount)
        if invoice_period is not None:
            pulumi.set(__self__, "invoice_period", invoice_period)
        if invoice_uuid is not None:
            pulumi.set(__self__, "invoice_uuid", invoice_uuid)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter
    def amount(self) -> Optional[str]:
        """
        Total amount of the invoice, in USD.  This will reflect month-to-date usage in the invoice preview.
        """
        return pulumi.get(self, "amount")

    @property
    @pulumi.getter(name="invoicePeriod")
    def invoice_period(self) -> Optional[str]:
        """
        Billing period of usage for which the invoice is issued, in `YYYY-MM`  format.
        """
        return pulumi.get(self, "invoice_period")

    @property
    @pulumi.getter(name="invoiceUuid")
    def invoice_uuid(self) -> Optional[str]:
        """
        The UUID of the invoice. The canonical reference for the invoice.
        """
        return pulumi.get(self, "invoice_uuid")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[str]:
        """
        Time the invoice was last updated.  This is only included with the invoice preview.
        """
        return pulumi.get(self, "updated_at")


@pulumi.output_type
class ListBillingHistoryItems(dict):
    def __init__(__self__, *,
                 meta: 'outputs.MetaProperties',
                 billing_history: Optional[Sequence['outputs.BillingHistory']] = None,
                 links: Optional['outputs.PageLinks'] = None):
        """
        :param 'MetaProperties' meta: Information about the response itself.
        """
        pulumi.set(__self__, "meta", meta)
        if billing_history is not None:
            pulumi.set(__self__, "billing_history", billing_history)
        if links is not None:
            pulumi.set(__self__, "links", links)

    @property
    @pulumi.getter
    def meta(self) -> 'outputs.MetaProperties':
        """
        Information about the response itself.
        """
        return pulumi.get(self, "meta")

    @property
    @pulumi.getter(name="billingHistory")
    def billing_history(self) -> Optional[Sequence['outputs.BillingHistory']]:
        return pulumi.get(self, "billing_history")

    @property
    @pulumi.getter
    def links(self) -> Optional['outputs.PageLinks']:
        return pulumi.get(self, "links")


@pulumi.output_type
class ListInvoicesItems(dict):
    def __init__(__self__, *,
                 meta: 'outputs.MetaMeta',
                 invoice_preview: Optional['outputs.InvoicePreview'] = None,
                 invoices: Optional[Sequence['outputs.InvoicePreview']] = None,
                 links: Optional['outputs.PageLinks'] = None):
        """
        :param 'InvoicePreview' invoice_preview: The invoice preview.
        """
        pulumi.set(__self__, "meta", meta)
        if invoice_preview is not None:
            pulumi.set(__self__, "invoice_preview", invoice_preview)
        if invoices is not None:
            pulumi.set(__self__, "invoices", invoices)
        if links is not None:
            pulumi.set(__self__, "links", links)

    @property
    @pulumi.getter
    def meta(self) -> 'outputs.MetaMeta':
        return pulumi.get(self, "meta")

    @property
    @pulumi.getter(name="invoicePreview")
    def invoice_preview(self) -> Optional['outputs.InvoicePreview']:
        """
        The invoice preview.
        """
        return pulumi.get(self, "invoice_preview")

    @property
    @pulumi.getter
    def invoices(self) -> Optional[Sequence['outputs.InvoicePreview']]:
        return pulumi.get(self, "invoices")

    @property
    @pulumi.getter
    def links(self) -> Optional['outputs.PageLinks']:
        return pulumi.get(self, "links")


@pulumi.output_type
class MetaMeta(dict):
    def __init__(__self__, *,
                 total: Optional[int] = None):
        """
        :param int total: Number of objects returned by the request.
        """
        if total is not None:
            pulumi.set(__self__, "total", total)

    @property
    @pulumi.getter
    def total(self) -> Optional[int]:
        """
        Number of objects returned by the request.
        """
        return pulumi.get(self, "total")


@pulumi.output_type
class MetaProperties(dict):
    """
    Information about the response itself.
    """
    def __init__(__self__, *,
                 total: Optional[int] = None):
        """
        Information about the response itself.
        :param int total: Number of objects returned by the request.
        """
        if total is not None:
            pulumi.set(__self__, "total", total)

    @property
    @pulumi.getter
    def total(self) -> Optional[int]:
        """
        Number of objects returned by the request.
        """
        return pulumi.get(self, "total")


@pulumi.output_type
class PageLinks(dict):
    def __init__(__self__, *,
                 pages: Optional['outputs.PageLinksPagesProperties'] = None):
        if pages is not None:
            pulumi.set(__self__, "pages", pages)

    @property
    @pulumi.getter
    def pages(self) -> Optional['outputs.PageLinksPagesProperties']:
        return pulumi.get(self, "pages")


@pulumi.output_type
class PageLinksPagesProperties(dict):
    def __init__(__self__, *,
                 first: Optional[str] = None,
                 last: Optional[str] = None,
                 next: Optional[str] = None,
                 prev: Optional[str] = None):
        if first is not None:
            pulumi.set(__self__, "first", first)
        if last is not None:
            pulumi.set(__self__, "last", last)
        if next is not None:
            pulumi.set(__self__, "next", next)
        if prev is not None:
            pulumi.set(__self__, "prev", prev)

    @property
    @pulumi.getter
    def first(self) -> Optional[str]:
        return pulumi.get(self, "first")

    @property
    @pulumi.getter
    def last(self) -> Optional[str]:
        return pulumi.get(self, "last")

    @property
    @pulumi.getter
    def next(self) -> Optional[str]:
        return pulumi.get(self, "next")

    @property
    @pulumi.getter
    def prev(self) -> Optional[str]:
        return pulumi.get(self, "prev")


