# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from ._enums import *

__all__ = ['DatabasesEvictionPolicyArgs', 'DatabasesEvictionPolicy']

@pulumi.input_type
class DatabasesEvictionPolicyArgs:
    def __init__(__self__, *,
                 eviction_policy: pulumi.Input['EvictionPolicy'],
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a DatabasesEvictionPolicy resource.
        :param pulumi.Input['EvictionPolicy'] eviction_policy: A string specifying the desired eviction policy for the Redis cluster.
               
               - `noeviction`: Don't evict any data, returns error when memory limit is reached.
               - `allkeys_lru:` Evict any key, least recently used (LRU) first.
               - `allkeys_random`: Evict keys in a random order.
               - `volatile_lru`: Evict keys with expiration only, least recently used (LRU) first.
               - `volatile_random`: Evict keys with expiration only in a random order.
               - `volatile_ttl`: Evict keys with expiration only, shortest time-to-live (TTL) first.
        :param pulumi.Input[str] database_cluster_uuid: A unique identifier for a database cluster.
        """
        pulumi.set(__self__, "eviction_policy", eviction_policy)
        if database_cluster_uuid is not None:
            pulumi.set(__self__, "database_cluster_uuid", database_cluster_uuid)

    @property
    @pulumi.getter(name="evictionPolicy")
    def eviction_policy(self) -> pulumi.Input['EvictionPolicy']:
        """
        A string specifying the desired eviction policy for the Redis cluster.

        - `noeviction`: Don't evict any data, returns error when memory limit is reached.
        - `allkeys_lru:` Evict any key, least recently used (LRU) first.
        - `allkeys_random`: Evict keys in a random order.
        - `volatile_lru`: Evict keys with expiration only, least recently used (LRU) first.
        - `volatile_random`: Evict keys with expiration only in a random order.
        - `volatile_ttl`: Evict keys with expiration only, shortest time-to-live (TTL) first.
        """
        return pulumi.get(self, "eviction_policy")

    @eviction_policy.setter
    def eviction_policy(self, value: pulumi.Input['EvictionPolicy']):
        pulumi.set(self, "eviction_policy", value)

    @property
    @pulumi.getter(name="databaseClusterUuid")
    def database_cluster_uuid(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for a database cluster.
        """
        return pulumi.get(self, "database_cluster_uuid")

    @database_cluster_uuid.setter
    def database_cluster_uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database_cluster_uuid", value)


class DatabasesEvictionPolicy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None,
                 eviction_policy: Optional[pulumi.Input['EvictionPolicy']] = None,
                 __props__=None):
        """
        Create a DatabasesEvictionPolicy resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] database_cluster_uuid: A unique identifier for a database cluster.
        :param pulumi.Input['EvictionPolicy'] eviction_policy: A string specifying the desired eviction policy for the Redis cluster.
               
               - `noeviction`: Don't evict any data, returns error when memory limit is reached.
               - `allkeys_lru:` Evict any key, least recently used (LRU) first.
               - `allkeys_random`: Evict keys in a random order.
               - `volatile_lru`: Evict keys with expiration only, least recently used (LRU) first.
               - `volatile_random`: Evict keys with expiration only in a random order.
               - `volatile_ttl`: Evict keys with expiration only, shortest time-to-live (TTL) first.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DatabasesEvictionPolicyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a DatabasesEvictionPolicy resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param DatabasesEvictionPolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DatabasesEvictionPolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None,
                 eviction_policy: Optional[pulumi.Input['EvictionPolicy']] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DatabasesEvictionPolicyArgs.__new__(DatabasesEvictionPolicyArgs)

            __props__.__dict__["database_cluster_uuid"] = database_cluster_uuid
            if eviction_policy is None and not opts.urn:
                raise TypeError("Missing required property 'eviction_policy'")
            __props__.__dict__["eviction_policy"] = eviction_policy
        super(DatabasesEvictionPolicy, __self__).__init__(
            'digitalocean-native:databases/v2:DatabasesEvictionPolicy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DatabasesEvictionPolicy':
        """
        Get an existing DatabasesEvictionPolicy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DatabasesEvictionPolicyArgs.__new__(DatabasesEvictionPolicyArgs)

        __props__.__dict__["eviction_policy"] = None
        return DatabasesEvictionPolicy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="evictionPolicy")
    def eviction_policy(self) -> pulumi.Output['EvictionPolicy']:
        """
        A string specifying the desired eviction policy for the Redis cluster.

        - `noeviction`: Don't evict any data, returns error when memory limit is reached.
        - `allkeys_lru:` Evict any key, least recently used (LRU) first.
        - `allkeys_random`: Evict keys in a random order.
        - `volatile_lru`: Evict keys with expiration only, least recently used (LRU) first.
        - `volatile_random`: Evict keys with expiration only in a random order.
        - `volatile_ttl`: Evict keys with expiration only, shortest time-to-live (TTL) first.
        """
        return pulumi.get(self, "eviction_policy")

