# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['DatabasesReAuthArgs', 'DatabasesReAuth']

@pulumi.input_type
class DatabasesReAuthArgs:
    def __init__(__self__, *,
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None,
                 mysql_settings: Optional[pulumi.Input['MysqlSettingsArgs']] = None,
                 username: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a DatabasesReAuth resource.
        :param pulumi.Input[str] database_cluster_uuid: A unique identifier for a database cluster.
        :param pulumi.Input[str] username: The name of the database user.
        """
        if database_cluster_uuid is not None:
            pulumi.set(__self__, "database_cluster_uuid", database_cluster_uuid)
        if mysql_settings is not None:
            pulumi.set(__self__, "mysql_settings", mysql_settings)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="databaseClusterUuid")
    def database_cluster_uuid(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for a database cluster.
        """
        return pulumi.get(self, "database_cluster_uuid")

    @database_cluster_uuid.setter
    def database_cluster_uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database_cluster_uuid", value)

    @property
    @pulumi.getter(name="mysqlSettings")
    def mysql_settings(self) -> Optional[pulumi.Input['MysqlSettingsArgs']]:
        return pulumi.get(self, "mysql_settings")

    @mysql_settings.setter
    def mysql_settings(self, value: Optional[pulumi.Input['MysqlSettingsArgs']]):
        pulumi.set(self, "mysql_settings", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the database user.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "username", value)


class DatabasesReAuth(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None,
                 mysql_settings: Optional[pulumi.Input[Union['MysqlSettingsArgs', 'MysqlSettingsArgsDict']]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a DatabasesReAuth resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] database_cluster_uuid: A unique identifier for a database cluster.
        :param pulumi.Input[str] username: The name of the database user.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[DatabasesReAuthArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a DatabasesReAuth resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param DatabasesReAuthArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DatabasesReAuthArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None,
                 mysql_settings: Optional[pulumi.Input[Union['MysqlSettingsArgs', 'MysqlSettingsArgsDict']]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DatabasesReAuthArgs.__new__(DatabasesReAuthArgs)

            __props__.__dict__["database_cluster_uuid"] = database_cluster_uuid
            __props__.__dict__["mysql_settings"] = mysql_settings
            __props__.__dict__["username"] = username
            __props__.__dict__["user"] = None
        super(DatabasesReAuth, __self__).__init__(
            'digitalocean-native:databases/v2:DatabasesReAuth',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DatabasesReAuth':
        """
        Get an existing DatabasesReAuth resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DatabasesReAuthArgs.__new__(DatabasesReAuthArgs)

        __props__.__dict__["mysql_settings"] = None
        __props__.__dict__["user"] = None
        return DatabasesReAuth(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="mysqlSettings")
    def mysql_settings(self) -> pulumi.Output[Optional['outputs.MysqlSettings']]:
        return pulumi.get(self, "mysql_settings")

    @property
    @pulumi.getter
    def user(self) -> pulumi.Output['outputs.DatabaseUser']:
        return pulumi.get(self, "user")

