# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = ['DatabasesRegionArgs', 'DatabasesRegion']

@pulumi.input_type
class DatabasesRegionArgs:
    def __init__(__self__, *,
                 region: pulumi.Input[str],
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a DatabasesRegion resource.
        :param pulumi.Input[str] region: A slug identifier for the region to which the database cluster will be migrated.
        :param pulumi.Input[str] database_cluster_uuid: A unique identifier for a database cluster.
        """
        pulumi.set(__self__, "region", region)
        if database_cluster_uuid is not None:
            pulumi.set(__self__, "database_cluster_uuid", database_cluster_uuid)

    @property
    @pulumi.getter
    def region(self) -> pulumi.Input[str]:
        """
        A slug identifier for the region to which the database cluster will be migrated.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: pulumi.Input[str]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="databaseClusterUuid")
    def database_cluster_uuid(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for a database cluster.
        """
        return pulumi.get(self, "database_cluster_uuid")

    @database_cluster_uuid.setter
    def database_cluster_uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database_cluster_uuid", value)


class DatabasesRegion(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a DatabasesRegion resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] database_cluster_uuid: A unique identifier for a database cluster.
        :param pulumi.Input[str] region: A slug identifier for the region to which the database cluster will be migrated.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DatabasesRegionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a DatabasesRegion resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param DatabasesRegionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DatabasesRegionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_cluster_uuid: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DatabasesRegionArgs.__new__(DatabasesRegionArgs)

            __props__.__dict__["database_cluster_uuid"] = database_cluster_uuid
            if region is None and not opts.urn:
                raise TypeError("Missing required property 'region'")
            __props__.__dict__["region"] = region
        super(DatabasesRegion, __self__).__init__(
            'digitalocean-native:databases/v2:DatabasesRegion',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DatabasesRegion':
        """
        Get an existing DatabasesRegion resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DatabasesRegionArgs.__new__(DatabasesRegionArgs)

        __props__.__dict__["region"] = None
        return DatabasesRegion(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        A slug identifier for the region to which the database cluster will be migrated.
        """
        return pulumi.get(self, "region")

