# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'Domain',
    'DomainRecord',
    'GetDomainProperties',
    'GetDomainsRecordProperties',
    'ListDomainsItems',
    'ListDomainsRecordsItems',
    'MetaMeta',
    'PageLinks',
    'PageLinksPagesProperties',
]

@pulumi.output_type
class Domain(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipAddress":
            suggest = "ip_address"
        elif key == "zoneFile":
            suggest = "zone_file"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in Domain. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        Domain.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        Domain.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip_address: Optional[str] = None,
                 name: Optional[str] = None,
                 ttl: Optional[int] = None,
                 zone_file: Optional[str] = None):
        """
        :param str ip_address: This optional attribute may contain an IP address. When provided, an A record will be automatically created pointing to the apex domain.
        :param str name: The name of the domain itself. This should follow the standard domain format of domain.TLD. For instance, `example.com` is a valid domain name.
        :param int ttl: This value is the time to live for the records on this domain, in seconds. This defines the time frame that clients can cache queried information before a refresh should be requested.
        :param str zone_file: This attribute contains the complete contents of the zone file for the selected domain. Individual domain record resources should be used to get more granular control over records. However, this attribute can also be used to get information about the SOA record, which is created automatically and is not accessible as an individual record resource.
        """
        if ip_address is not None:
            pulumi.set(__self__, "ip_address", ip_address)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if ttl is not None:
            pulumi.set(__self__, "ttl", ttl)
        if zone_file is not None:
            pulumi.set(__self__, "zone_file", zone_file)

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> Optional[str]:
        """
        This optional attribute may contain an IP address. When provided, an A record will be automatically created pointing to the apex domain.
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of the domain itself. This should follow the standard domain format of domain.TLD. For instance, `example.com` is a valid domain name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def ttl(self) -> Optional[int]:
        """
        This value is the time to live for the records on this domain, in seconds. This defines the time frame that clients can cache queried information before a refresh should be requested.
        """
        return pulumi.get(self, "ttl")

    @property
    @pulumi.getter(name="zoneFile")
    def zone_file(self) -> Optional[str]:
        """
        This attribute contains the complete contents of the zone file for the selected domain. Individual domain record resources should be used to get more granular control over records. However, this attribute can also be used to get information about the SOA record, which is created automatically and is not accessible as an individual record resource.
        """
        return pulumi.get(self, "zone_file")


@pulumi.output_type
class DomainRecord(dict):
    def __init__(__self__, *,
                 type: str,
                 data: Optional[str] = None,
                 flags: Optional[int] = None,
                 id: Optional[int] = None,
                 name: Optional[str] = None,
                 port: Optional[int] = None,
                 priority: Optional[int] = None,
                 tag: Optional[str] = None,
                 ttl: Optional[int] = None,
                 weight: Optional[int] = None):
        """
        :param str type: The type of the DNS record. For example: A, CNAME, TXT, ...
        :param str data: Variable data depending on record type. For example, the "data" value for an A record would be the IPv4 address to which the domain will be mapped. For a CAA record, it would contain the domain name of the CA being granted permission to issue certificates.
        :param int flags: An unsigned integer between 0-255 used for CAA records.
        :param int id: A unique identifier for each domain record.
        :param str name: The host name, alias, or service being defined by the record.
        :param int port: The port for SRV records.
        :param int priority: The priority for SRV and MX records.
        :param str tag: The parameter tag for CAA records. Valid values are "issue", "issuewild", or "iodef"
        :param int ttl: This value is the time to live for the record, in seconds. This defines the time frame that clients can cache queried information before a refresh should be requested.
        :param int weight: The weight for SRV records.
        """
        pulumi.set(__self__, "type", type)
        if data is not None:
            pulumi.set(__self__, "data", data)
        if flags is not None:
            pulumi.set(__self__, "flags", flags)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if tag is not None:
            pulumi.set(__self__, "tag", tag)
        if ttl is not None:
            pulumi.set(__self__, "ttl", ttl)
        if weight is not None:
            pulumi.set(__self__, "weight", weight)

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the DNS record. For example: A, CNAME, TXT, ...
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def data(self) -> Optional[str]:
        """
        Variable data depending on record type. For example, the "data" value for an A record would be the IPv4 address to which the domain will be mapped. For a CAA record, it would contain the domain name of the CA being granted permission to issue certificates.
        """
        return pulumi.get(self, "data")

    @property
    @pulumi.getter
    def flags(self) -> Optional[int]:
        """
        An unsigned integer between 0-255 used for CAA records.
        """
        return pulumi.get(self, "flags")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        A unique identifier for each domain record.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The host name, alias, or service being defined by the record.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def port(self) -> Optional[int]:
        """
        The port for SRV records.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def priority(self) -> Optional[int]:
        """
        The priority for SRV and MX records.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter
    def tag(self) -> Optional[str]:
        """
        The parameter tag for CAA records. Valid values are "issue", "issuewild", or "iodef"
        """
        return pulumi.get(self, "tag")

    @property
    @pulumi.getter
    def ttl(self) -> Optional[int]:
        """
        This value is the time to live for the record, in seconds. This defines the time frame that clients can cache queried information before a refresh should be requested.
        """
        return pulumi.get(self, "ttl")

    @property
    @pulumi.getter
    def weight(self) -> Optional[int]:
        """
        The weight for SRV records.
        """
        return pulumi.get(self, "weight")


@pulumi.output_type
class GetDomainProperties(dict):
    def __init__(__self__, *,
                 domain: Optional['outputs.Domain'] = None):
        if domain is not None:
            pulumi.set(__self__, "domain", domain)

    @property
    @pulumi.getter
    def domain(self) -> Optional['outputs.Domain']:
        return pulumi.get(self, "domain")


@pulumi.output_type
class GetDomainsRecordProperties(dict):
    def __init__(__self__, *,
                 domain_record: Optional['outputs.DomainRecord'] = None):
        if domain_record is not None:
            pulumi.set(__self__, "domain_record", domain_record)

    @property
    @pulumi.getter(name="domainRecord")
    def domain_record(self) -> Optional['outputs.DomainRecord']:
        return pulumi.get(self, "domain_record")


@pulumi.output_type
class ListDomainsItems(dict):
    def __init__(__self__, *,
                 domains: Sequence['outputs.Domain'],
                 meta: 'outputs.MetaMeta',
                 links: Optional['outputs.PageLinks'] = None):
        """
        :param Sequence['Domain'] domains: Array of volumes.
        """
        pulumi.set(__self__, "domains", domains)
        pulumi.set(__self__, "meta", meta)
        if links is not None:
            pulumi.set(__self__, "links", links)

    @property
    @pulumi.getter
    def domains(self) -> Sequence['outputs.Domain']:
        """
        Array of volumes.
        """
        return pulumi.get(self, "domains")

    @property
    @pulumi.getter
    def meta(self) -> 'outputs.MetaMeta':
        return pulumi.get(self, "meta")

    @property
    @pulumi.getter
    def links(self) -> Optional['outputs.PageLinks']:
        return pulumi.get(self, "links")


@pulumi.output_type
class ListDomainsRecordsItems(dict):
    def __init__(__self__, *,
                 meta: 'outputs.MetaMeta',
                 domain_records: Optional[Sequence['outputs.DomainRecord']] = None,
                 links: Optional['outputs.PageLinks'] = None):
        pulumi.set(__self__, "meta", meta)
        if domain_records is not None:
            pulumi.set(__self__, "domain_records", domain_records)
        if links is not None:
            pulumi.set(__self__, "links", links)

    @property
    @pulumi.getter
    def meta(self) -> 'outputs.MetaMeta':
        return pulumi.get(self, "meta")

    @property
    @pulumi.getter(name="domainRecords")
    def domain_records(self) -> Optional[Sequence['outputs.DomainRecord']]:
        return pulumi.get(self, "domain_records")

    @property
    @pulumi.getter
    def links(self) -> Optional['outputs.PageLinks']:
        return pulumi.get(self, "links")


@pulumi.output_type
class MetaMeta(dict):
    def __init__(__self__, *,
                 total: Optional[int] = None):
        """
        :param int total: Number of objects returned by the request.
        """
        if total is not None:
            pulumi.set(__self__, "total", total)

    @property
    @pulumi.getter
    def total(self) -> Optional[int]:
        """
        Number of objects returned by the request.
        """
        return pulumi.get(self, "total")


@pulumi.output_type
class PageLinks(dict):
    def __init__(__self__, *,
                 pages: Optional['outputs.PageLinksPagesProperties'] = None):
        if pages is not None:
            pulumi.set(__self__, "pages", pages)

    @property
    @pulumi.getter
    def pages(self) -> Optional['outputs.PageLinksPagesProperties']:
        return pulumi.get(self, "pages")


@pulumi.output_type
class PageLinksPagesProperties(dict):
    def __init__(__self__, *,
                 first: Optional[str] = None,
                 last: Optional[str] = None,
                 next: Optional[str] = None,
                 prev: Optional[str] = None):
        if first is not None:
            pulumi.set(__self__, "first", first)
        if last is not None:
            pulumi.set(__self__, "last", last)
        if next is not None:
            pulumi.set(__self__, "next", next)
        if prev is not None:
            pulumi.set(__self__, "prev", prev)

    @property
    @pulumi.getter
    def first(self) -> Optional[str]:
        return pulumi.get(self, "first")

    @property
    @pulumi.getter
    def last(self) -> Optional[str]:
        return pulumi.get(self, "last")

    @property
    @pulumi.getter
    def next(self) -> Optional[str]:
        return pulumi.get(self, "next")

    @property
    @pulumi.getter
    def prev(self) -> Optional[str]:
        return pulumi.get(self, "prev")


