# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetFunctionsNamespaceProperties',
    'GetFunctionsTriggerProperties',
    'ListFunctionsNamespacesItems',
    'ListFunctionsTriggersItems',
    'NamespaceInfo',
    'ScheduledDetails',
    'ScheduledDetailsBodyProperties',
    'TriggerInfo',
    'TriggerInfoScheduledRunsProperties',
]

@pulumi.output_type
class GetFunctionsNamespaceProperties(dict):
    def __init__(__self__, *,
                 namespace: Optional['outputs.NamespaceInfo'] = None):
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)

    @property
    @pulumi.getter
    def namespace(self) -> Optional['outputs.NamespaceInfo']:
        return pulumi.get(self, "namespace")


@pulumi.output_type
class GetFunctionsTriggerProperties(dict):
    def __init__(__self__, *,
                 trigger: Optional['outputs.TriggerInfo'] = None):
        if trigger is not None:
            pulumi.set(__self__, "trigger", trigger)

    @property
    @pulumi.getter
    def trigger(self) -> Optional['outputs.TriggerInfo']:
        return pulumi.get(self, "trigger")


@pulumi.output_type
class ListFunctionsNamespacesItems(dict):
    def __init__(__self__, *,
                 namespaces: Optional[Sequence['outputs.NamespaceInfo']] = None):
        if namespaces is not None:
            pulumi.set(__self__, "namespaces", namespaces)

    @property
    @pulumi.getter
    def namespaces(self) -> Optional[Sequence['outputs.NamespaceInfo']]:
        return pulumi.get(self, "namespaces")


@pulumi.output_type
class ListFunctionsTriggersItems(dict):
    def __init__(__self__, *,
                 triggers: Optional[Sequence['outputs.TriggerInfo']] = None):
        if triggers is not None:
            pulumi.set(__self__, "triggers", triggers)

    @property
    @pulumi.getter
    def triggers(self) -> Optional[Sequence['outputs.TriggerInfo']]:
        return pulumi.get(self, "triggers")


@pulumi.output_type
class NamespaceInfo(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "apiHost":
            suggest = "api_host"
        elif key == "createdAt":
            suggest = "created_at"
        elif key == "updatedAt":
            suggest = "updated_at"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in NamespaceInfo. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        NamespaceInfo.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        NamespaceInfo.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 api_host: Optional[str] = None,
                 created_at: Optional[str] = None,
                 key: Optional[str] = None,
                 label: Optional[str] = None,
                 namespace: Optional[str] = None,
                 region: Optional[str] = None,
                 updated_at: Optional[str] = None,
                 uuid: Optional[str] = None):
        """
        :param str api_host: The namespace's API hostname. Each function in a namespace is provided an endpoint at the namespace's hostname.
        :param str created_at: UTC time string.
        :param str key: A random alpha numeric string. This key is used in conjunction with the namespace's UUID to authenticate 
               a user to use the namespace via `doctl`, DigitalOcean's official CLI.
        :param str label: The namespace's unique name.
        :param str namespace: A unique string format of UUID with a prefix fn-.
        :param str region: The namespace's datacenter region.
        :param str updated_at: UTC time string.
        :param str uuid: The namespace's Universally Unique Identifier.
        """
        if api_host is not None:
            pulumi.set(__self__, "api_host", api_host)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if key is not None:
            pulumi.set(__self__, "key", key)
        if label is not None:
            pulumi.set(__self__, "label", label)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter(name="apiHost")
    def api_host(self) -> Optional[str]:
        """
        The namespace's API hostname. Each function in a namespace is provided an endpoint at the namespace's hostname.
        """
        return pulumi.get(self, "api_host")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        UTC time string.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def key(self) -> Optional[str]:
        """
        A random alpha numeric string. This key is used in conjunction with the namespace's UUID to authenticate 
        a user to use the namespace via `doctl`, DigitalOcean's official CLI.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def label(self) -> Optional[str]:
        """
        The namespace's unique name.
        """
        return pulumi.get(self, "label")

    @property
    @pulumi.getter
    def namespace(self) -> Optional[str]:
        """
        A unique string format of UUID with a prefix fn-.
        """
        return pulumi.get(self, "namespace")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        """
        The namespace's datacenter region.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[str]:
        """
        UTC time string.
        """
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter
    def uuid(self) -> Optional[str]:
        """
        The namespace's Universally Unique Identifier.
        """
        return pulumi.get(self, "uuid")


@pulumi.output_type
class ScheduledDetails(dict):
    """
    Trigger details for SCHEDULED type, where body is optional.
    """
    def __init__(__self__, *,
                 cron: str,
                 body: Optional['outputs.ScheduledDetailsBodyProperties'] = None):
        """
        Trigger details for SCHEDULED type, where body is optional.

        :param str cron: valid cron expression string which is required for SCHEDULED type triggers.
        :param 'ScheduledDetailsBodyProperties' body: Optional data to be sent to function while triggering the function.
        """
        pulumi.set(__self__, "cron", cron)
        if body is not None:
            pulumi.set(__self__, "body", body)

    @property
    @pulumi.getter
    def cron(self) -> str:
        """
        valid cron expression string which is required for SCHEDULED type triggers.
        """
        return pulumi.get(self, "cron")

    @property
    @pulumi.getter
    def body(self) -> Optional['outputs.ScheduledDetailsBodyProperties']:
        """
        Optional data to be sent to function while triggering the function.
        """
        return pulumi.get(self, "body")


@pulumi.output_type
class ScheduledDetailsBodyProperties(dict):
    """
    Optional data to be sent to function while triggering the function.
    """
    def __init__(__self__, *,
                 name: Optional[str] = None):
        """
        Optional data to be sent to function while triggering the function.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")


@pulumi.output_type
class TriggerInfo(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "isEnabled":
            suggest = "is_enabled"
        elif key == "scheduledDetails":
            suggest = "scheduled_details"
        elif key == "scheduledRuns":
            suggest = "scheduled_runs"
        elif key == "updatedAt":
            suggest = "updated_at"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TriggerInfo. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TriggerInfo.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TriggerInfo.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 function: Optional[str] = None,
                 is_enabled: Optional[bool] = None,
                 name: Optional[str] = None,
                 namespace: Optional[str] = None,
                 scheduled_details: Optional['outputs.ScheduledDetails'] = None,
                 scheduled_runs: Optional['outputs.TriggerInfoScheduledRunsProperties'] = None,
                 type: Optional[str] = None,
                 updated_at: Optional[str] = None):
        """
        :param str created_at: UTC time string.
        :param str function: Name of function(action) that exists in the given namespace.
        :param bool is_enabled: Indicates weather the trigger is paused or unpaused.
        :param str name: The trigger's unique name within the namespace.
        :param str namespace: A unique string format of UUID with a prefix fn-.
        :param 'ScheduledDetails' scheduled_details: Trigger details for SCHEDULED type, where body is optional.
        :param str type: String which indicates the type of trigger source like SCHEDULED.
        :param str updated_at: UTC time string.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if function is not None:
            pulumi.set(__self__, "function", function)
        if is_enabled is not None:
            pulumi.set(__self__, "is_enabled", is_enabled)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)
        if scheduled_details is not None:
            pulumi.set(__self__, "scheduled_details", scheduled_details)
        if scheduled_runs is not None:
            pulumi.set(__self__, "scheduled_runs", scheduled_runs)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        UTC time string.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def function(self) -> Optional[str]:
        """
        Name of function(action) that exists in the given namespace.
        """
        return pulumi.get(self, "function")

    @property
    @pulumi.getter(name="isEnabled")
    def is_enabled(self) -> Optional[bool]:
        """
        Indicates weather the trigger is paused or unpaused.
        """
        return pulumi.get(self, "is_enabled")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The trigger's unique name within the namespace.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def namespace(self) -> Optional[str]:
        """
        A unique string format of UUID with a prefix fn-.
        """
        return pulumi.get(self, "namespace")

    @property
    @pulumi.getter(name="scheduledDetails")
    def scheduled_details(self) -> Optional['outputs.ScheduledDetails']:
        """
        Trigger details for SCHEDULED type, where body is optional.
        """
        return pulumi.get(self, "scheduled_details")

    @property
    @pulumi.getter(name="scheduledRuns")
    def scheduled_runs(self) -> Optional['outputs.TriggerInfoScheduledRunsProperties']:
        return pulumi.get(self, "scheduled_runs")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        String which indicates the type of trigger source like SCHEDULED.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[str]:
        """
        UTC time string.
        """
        return pulumi.get(self, "updated_at")


@pulumi.output_type
class TriggerInfoScheduledRunsProperties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "lastRunAt":
            suggest = "last_run_at"
        elif key == "nextRunAt":
            suggest = "next_run_at"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TriggerInfoScheduledRunsProperties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TriggerInfoScheduledRunsProperties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TriggerInfoScheduledRunsProperties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 last_run_at: Optional[str] = None,
                 next_run_at: Optional[str] = None):
        """
        :param str last_run_at: Indicates last run time. null value indicates trigger not run yet.
        :param str next_run_at: Indicates next run time. null value indicates trigger will not run.
        """
        if last_run_at is not None:
            pulumi.set(__self__, "last_run_at", last_run_at)
        if next_run_at is not None:
            pulumi.set(__self__, "next_run_at", next_run_at)

    @property
    @pulumi.getter(name="lastRunAt")
    def last_run_at(self) -> Optional[str]:
        """
        Indicates last run time. null value indicates trigger not run yet.
        """
        return pulumi.get(self, "last_run_at")

    @property
    @pulumi.getter(name="nextRunAt")
    def next_run_at(self) -> Optional[str]:
        """
        Indicates next run time. null value indicates trigger will not run.
        """
        return pulumi.get(self, "next_run_at")


