# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'AssociatedKubernetesResource',
    'AssociatedKubernetesResources',
    'Cluster',
    'ClusterStatusProperties',
    'ClusterlintResults',
    'ClusterlintResultsDiagnosticsItemProperties',
    'ClusterlintResultsDiagnosticsItemPropertiesObjectProperties',
    'Credentials',
    'GetKubernetesAvailableUpgradeProperties',
    'GetKubernetesClusterProperties',
    'GetKubernetesNodePoolProperties',
    'KubernetesNodePool',
    'KubernetesNodePoolTaint',
    'KubernetesOptions',
    'KubernetesOptionsOptionsProperties',
    'KubernetesRegion',
    'KubernetesSize',
    'KubernetesVersion',
    'ListKubernetesClustersItems',
    'ListKubernetesNodePoolsProperties',
    'MaintenancePolicy',
    'MetaMeta',
    'Node',
    'NodeStatusProperties',
    'PageLinks',
    'PageLinksPagesProperties',
    'StatusProperties',
    'User',
    'UserKubernetesClusterUserProperties',
]

@pulumi.output_type
class AssociatedKubernetesResource(dict):
    def __init__(__self__, *,
                 id: Optional[str] = None,
                 name: Optional[str] = None):
        """
        :param str id: The ID of a resource associated with a Kubernetes cluster.
        :param str name: The name of a resource associated with a Kubernetes cluster.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        The ID of a resource associated with a Kubernetes cluster.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of a resource associated with a Kubernetes cluster.
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class AssociatedKubernetesResources(dict):
    """
    An object containing the IDs of resources associated with a Kubernetes cluster.
    """
    def __init__(__self__, *,
                 load_balancers: Optional[Sequence['outputs.AssociatedKubernetesResource']] = None,
                 volume_snapshots: Optional[Sequence['outputs.AssociatedKubernetesResource']] = None,
                 volumes: Optional[Sequence['outputs.AssociatedKubernetesResource']] = None):
        """
        An object containing the IDs of resources associated with a Kubernetes cluster.
        :param Sequence['AssociatedKubernetesResource'] load_balancers: A list of names and IDs for associated load balancers that can be destroyed along with the cluster.
        :param Sequence['AssociatedKubernetesResource'] volume_snapshots: A list of names and IDs for associated volume snapshots that can be destroyed along with the cluster.
        :param Sequence['AssociatedKubernetesResource'] volumes: A list of names and IDs for associated volumes that can be destroyed along with the cluster.
        """
        if load_balancers is not None:
            pulumi.set(__self__, "load_balancers", load_balancers)
        if volume_snapshots is not None:
            pulumi.set(__self__, "volume_snapshots", volume_snapshots)
        if volumes is not None:
            pulumi.set(__self__, "volumes", volumes)

    @property
    @pulumi.getter(name="loadBalancers")
    def load_balancers(self) -> Optional[Sequence['outputs.AssociatedKubernetesResource']]:
        """
        A list of names and IDs for associated load balancers that can be destroyed along with the cluster.
        """
        return pulumi.get(self, "load_balancers")

    @property
    @pulumi.getter(name="volumeSnapshots")
    def volume_snapshots(self) -> Optional[Sequence['outputs.AssociatedKubernetesResource']]:
        """
        A list of names and IDs for associated volume snapshots that can be destroyed along with the cluster.
        """
        return pulumi.get(self, "volume_snapshots")

    @property
    @pulumi.getter
    def volumes(self) -> Optional[Sequence['outputs.AssociatedKubernetesResource']]:
        """
        A list of names and IDs for associated volumes that can be destroyed along with the cluster.
        """
        return pulumi.get(self, "volumes")


@pulumi.output_type
class Cluster(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "nodePools":
            suggest = "node_pools"
        elif key == "autoUpgrade":
            suggest = "auto_upgrade"
        elif key == "clusterSubnet":
            suggest = "cluster_subnet"
        elif key == "createdAt":
            suggest = "created_at"
        elif key == "maintenancePolicy":
            suggest = "maintenance_policy"
        elif key == "registryEnabled":
            suggest = "registry_enabled"
        elif key == "serviceSubnet":
            suggest = "service_subnet"
        elif key == "surgeUpgrade":
            suggest = "surge_upgrade"
        elif key == "updatedAt":
            suggest = "updated_at"
        elif key == "vpcUuid":
            suggest = "vpc_uuid"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in Cluster. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        Cluster.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        Cluster.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 node_pools: Sequence['outputs.KubernetesNodePool'],
                 region: str,
                 version: str,
                 auto_upgrade: Optional[bool] = None,
                 cluster_subnet: Optional[str] = None,
                 created_at: Optional[str] = None,
                 endpoint: Optional[str] = None,
                 ha: Optional[bool] = None,
                 id: Optional[str] = None,
                 ipv4: Optional[str] = None,
                 maintenance_policy: Optional['outputs.MaintenancePolicy'] = None,
                 registry_enabled: Optional[bool] = None,
                 service_subnet: Optional[str] = None,
                 status: Optional['outputs.ClusterStatusProperties'] = None,
                 surge_upgrade: Optional[bool] = None,
                 tags: Optional[Sequence[str]] = None,
                 updated_at: Optional[str] = None,
                 vpc_uuid: Optional[str] = None):
        """
        :param str name: A human-readable name for a Kubernetes cluster.
        :param Sequence['KubernetesNodePool'] node_pools: An object specifying the details of the worker nodes available to the Kubernetes cluster.
        :param str region: The slug identifier for the region where the Kubernetes cluster is located.
        :param str version: The slug identifier for the version of Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the latest version within it will be used (e.g. "1.14.6-do.1"); if set to "latest", the latest published version will be used. See the `/v2/kubernetes/options` endpoint to find all currently available versions.
        :param bool auto_upgrade: A boolean value indicating whether the cluster will be automatically upgraded to new patch releases during its maintenance window.
        :param str cluster_subnet: The range of IP addresses in the overlay network of the Kubernetes cluster in CIDR notation.
        :param str created_at: A time value given in ISO8601 combined date and time format that represents when the Kubernetes cluster was created.
        :param str endpoint: The base URL of the API server on the Kubernetes master node.
        :param bool ha: A boolean value indicating whether the control plane is run in a highly available configuration in the cluster. Highly available control planes incur less downtime. The property cannot be disabled.
        :param str id: A unique ID that can be used to identify and reference a Kubernetes cluster.
        :param str ipv4: The public IPv4 address of the Kubernetes master node. This will not be set if high availability is configured on the cluster (v1.21+)
        :param 'MaintenancePolicy' maintenance_policy: An object specifying the maintenance window policy for the Kubernetes cluster.
        :param bool registry_enabled: A read-only boolean value indicating if a container registry is integrated with the cluster.
        :param str service_subnet: The range of assignable IP addresses for services running in the Kubernetes cluster in CIDR notation.
        :param 'ClusterStatusProperties' status: An object containing a `state` attribute whose value is set to a string indicating the current status of the cluster.
        :param bool surge_upgrade: A boolean value indicating whether surge upgrade is enabled/disabled for the cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing up new nodes before destroying the outdated nodes.
        :param Sequence[str] tags: An array of tags applied to the Kubernetes cluster. All clusters are automatically tagged `k8s` and `k8s:$K8S_CLUSTER_ID`.
        :param str updated_at: A time value given in ISO8601 combined date and time format that represents when the Kubernetes cluster was last updated.
        :param str vpc_uuid: A string specifying the UUID of the VPC to which the Kubernetes cluster is assigned.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "node_pools", node_pools)
        pulumi.set(__self__, "region", region)
        pulumi.set(__self__, "version", version)
        if auto_upgrade is None:
            auto_upgrade = False
        if auto_upgrade is not None:
            pulumi.set(__self__, "auto_upgrade", auto_upgrade)
        if cluster_subnet is not None:
            pulumi.set(__self__, "cluster_subnet", cluster_subnet)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if endpoint is not None:
            pulumi.set(__self__, "endpoint", endpoint)
        if ha is None:
            ha = False
        if ha is not None:
            pulumi.set(__self__, "ha", ha)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if ipv4 is not None:
            pulumi.set(__self__, "ipv4", ipv4)
        if maintenance_policy is not None:
            pulumi.set(__self__, "maintenance_policy", maintenance_policy)
        if registry_enabled is not None:
            pulumi.set(__self__, "registry_enabled", registry_enabled)
        if service_subnet is not None:
            pulumi.set(__self__, "service_subnet", service_subnet)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if surge_upgrade is None:
            surge_upgrade = False
        if surge_upgrade is not None:
            pulumi.set(__self__, "surge_upgrade", surge_upgrade)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if vpc_uuid is not None:
            pulumi.set(__self__, "vpc_uuid", vpc_uuid)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        A human-readable name for a Kubernetes cluster.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodePools")
    def node_pools(self) -> Sequence['outputs.KubernetesNodePool']:
        """
        An object specifying the details of the worker nodes available to the Kubernetes cluster.
        """
        return pulumi.get(self, "node_pools")

    @property
    @pulumi.getter
    def region(self) -> str:
        """
        The slug identifier for the region where the Kubernetes cluster is located.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def version(self) -> str:
        """
        The slug identifier for the version of Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the latest version within it will be used (e.g. "1.14.6-do.1"); if set to "latest", the latest published version will be used. See the `/v2/kubernetes/options` endpoint to find all currently available versions.
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="autoUpgrade")
    def auto_upgrade(self) -> Optional[bool]:
        """
        A boolean value indicating whether the cluster will be automatically upgraded to new patch releases during its maintenance window.
        """
        return pulumi.get(self, "auto_upgrade")

    @property
    @pulumi.getter(name="clusterSubnet")
    def cluster_subnet(self) -> Optional[str]:
        """
        The range of IP addresses in the overlay network of the Kubernetes cluster in CIDR notation.
        """
        return pulumi.get(self, "cluster_subnet")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        A time value given in ISO8601 combined date and time format that represents when the Kubernetes cluster was created.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def endpoint(self) -> Optional[str]:
        """
        The base URL of the API server on the Kubernetes master node.
        """
        return pulumi.get(self, "endpoint")

    @property
    @pulumi.getter
    def ha(self) -> Optional[bool]:
        """
        A boolean value indicating whether the control plane is run in a highly available configuration in the cluster. Highly available control planes incur less downtime. The property cannot be disabled.
        """
        return pulumi.get(self, "ha")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        A unique ID that can be used to identify and reference a Kubernetes cluster.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ipv4(self) -> Optional[str]:
        """
        The public IPv4 address of the Kubernetes master node. This will not be set if high availability is configured on the cluster (v1.21+)
        """
        return pulumi.get(self, "ipv4")

    @property
    @pulumi.getter(name="maintenancePolicy")
    def maintenance_policy(self) -> Optional['outputs.MaintenancePolicy']:
        """
        An object specifying the maintenance window policy for the Kubernetes cluster.
        """
        return pulumi.get(self, "maintenance_policy")

    @property
    @pulumi.getter(name="registryEnabled")
    def registry_enabled(self) -> Optional[bool]:
        """
        A read-only boolean value indicating if a container registry is integrated with the cluster.
        """
        return pulumi.get(self, "registry_enabled")

    @property
    @pulumi.getter(name="serviceSubnet")
    def service_subnet(self) -> Optional[str]:
        """
        The range of assignable IP addresses for services running in the Kubernetes cluster in CIDR notation.
        """
        return pulumi.get(self, "service_subnet")

    @property
    @pulumi.getter
    def status(self) -> Optional['outputs.ClusterStatusProperties']:
        """
        An object containing a `state` attribute whose value is set to a string indicating the current status of the cluster.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="surgeUpgrade")
    def surge_upgrade(self) -> Optional[bool]:
        """
        A boolean value indicating whether surge upgrade is enabled/disabled for the cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing up new nodes before destroying the outdated nodes.
        """
        return pulumi.get(self, "surge_upgrade")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Sequence[str]]:
        """
        An array of tags applied to the Kubernetes cluster. All clusters are automatically tagged `k8s` and `k8s:$K8S_CLUSTER_ID`.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[str]:
        """
        A time value given in ISO8601 combined date and time format that represents when the Kubernetes cluster was last updated.
        """
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter(name="vpcUuid")
    def vpc_uuid(self) -> Optional[str]:
        """
        A string specifying the UUID of the VPC to which the Kubernetes cluster is assigned.
        """
        return pulumi.get(self, "vpc_uuid")


@pulumi.output_type
class ClusterStatusProperties(dict):
    """
    An object containing a `state` attribute whose value is set to a string indicating the current status of the cluster.
    """
    def __init__(__self__, *,
                 message: Optional[str] = None,
                 state: Optional['ClusterStatusPropertiesState'] = None):
        """
        An object containing a `state` attribute whose value is set to a string indicating the current status of the cluster.
        :param str message: An optional message providing additional information about the current cluster state.
        :param 'ClusterStatusPropertiesState' state: A string indicating the current status of the cluster.
        """
        if message is not None:
            pulumi.set(__self__, "message", message)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter
    def message(self) -> Optional[str]:
        """
        An optional message providing additional information about the current cluster state.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter
    def state(self) -> Optional['ClusterStatusPropertiesState']:
        """
        A string indicating the current status of the cluster.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class ClusterlintResults(dict):
    def __init__(__self__, *,
                 completed_at: Optional[str] = None,
                 diagnostics: Optional[Sequence['outputs.ClusterlintResultsDiagnosticsItemProperties']] = None,
                 requested_at: Optional[str] = None,
                 run_id: Optional[str] = None):
        """
        :param str completed_at: A time value given in ISO8601 combined date and time format that represents when the schedule clusterlint run request was completed.
        :param Sequence['ClusterlintResultsDiagnosticsItemProperties'] diagnostics: An array of diagnostics reporting potential problems for the given cluster.
        :param str requested_at: A time value given in ISO8601 combined date and time format that represents when the schedule clusterlint run request was made.
        :param str run_id: Id of the clusterlint run that can be used later to fetch the diagnostics.
        """
        if completed_at is not None:
            pulumi.set(__self__, "completed_at", completed_at)
        if diagnostics is not None:
            pulumi.set(__self__, "diagnostics", diagnostics)
        if requested_at is not None:
            pulumi.set(__self__, "requested_at", requested_at)
        if run_id is not None:
            pulumi.set(__self__, "run_id", run_id)

    @property
    @pulumi.getter(name="completedAt")
    def completed_at(self) -> Optional[str]:
        """
        A time value given in ISO8601 combined date and time format that represents when the schedule clusterlint run request was completed.
        """
        return pulumi.get(self, "completed_at")

    @property
    @pulumi.getter
    def diagnostics(self) -> Optional[Sequence['outputs.ClusterlintResultsDiagnosticsItemProperties']]:
        """
        An array of diagnostics reporting potential problems for the given cluster.
        """
        return pulumi.get(self, "diagnostics")

    @property
    @pulumi.getter(name="requestedAt")
    def requested_at(self) -> Optional[str]:
        """
        A time value given in ISO8601 combined date and time format that represents when the schedule clusterlint run request was made.
        """
        return pulumi.get(self, "requested_at")

    @property
    @pulumi.getter(name="runId")
    def run_id(self) -> Optional[str]:
        """
        Id of the clusterlint run that can be used later to fetch the diagnostics.
        """
        return pulumi.get(self, "run_id")


@pulumi.output_type
class ClusterlintResultsDiagnosticsItemProperties(dict):
    def __init__(__self__, *,
                 check_name: Optional[str] = None,
                 message: Optional[str] = None,
                 object: Optional['outputs.ClusterlintResultsDiagnosticsItemPropertiesObjectProperties'] = None,
                 severity: Optional[str] = None):
        """
        :param str check_name: The clusterlint check that resulted in the diagnostic.
        :param str message: Feedback about the object for users to fix.
        :param 'ClusterlintResultsDiagnosticsItemPropertiesObjectProperties' object: Metadata about the Kubernetes API object the diagnostic is reported on.
        :param str severity: Can be one of error, warning or suggestion.
        """
        if check_name is not None:
            pulumi.set(__self__, "check_name", check_name)
        if message is not None:
            pulumi.set(__self__, "message", message)
        if object is not None:
            pulumi.set(__self__, "object", object)
        if severity is not None:
            pulumi.set(__self__, "severity", severity)

    @property
    @pulumi.getter(name="checkName")
    def check_name(self) -> Optional[str]:
        """
        The clusterlint check that resulted in the diagnostic.
        """
        return pulumi.get(self, "check_name")

    @property
    @pulumi.getter
    def message(self) -> Optional[str]:
        """
        Feedback about the object for users to fix.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter
    def object(self) -> Optional['outputs.ClusterlintResultsDiagnosticsItemPropertiesObjectProperties']:
        """
        Metadata about the Kubernetes API object the diagnostic is reported on.
        """
        return pulumi.get(self, "object")

    @property
    @pulumi.getter
    def severity(self) -> Optional[str]:
        """
        Can be one of error, warning or suggestion.
        """
        return pulumi.get(self, "severity")


@pulumi.output_type
class ClusterlintResultsDiagnosticsItemPropertiesObjectProperties(dict):
    """
    Metadata about the Kubernetes API object the diagnostic is reported on.
    """
    def __init__(__self__, *,
                 kind: Optional[str] = None,
                 name: Optional[str] = None,
                 namespace: Optional[str] = None):
        """
        Metadata about the Kubernetes API object the diagnostic is reported on.
        :param str kind: The kind of Kubernetes API object
        :param str name: Name of the object
        :param str namespace: The namespace the object resides in the cluster.
        """
        if kind is not None:
            pulumi.set(__self__, "kind", kind)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)

    @property
    @pulumi.getter
    def kind(self) -> Optional[str]:
        """
        The kind of Kubernetes API object
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Name of the object
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def namespace(self) -> Optional[str]:
        """
        The namespace the object resides in the cluster.
        """
        return pulumi.get(self, "namespace")


@pulumi.output_type
class Credentials(dict):
    def __init__(__self__, *,
                 certificate_authority_data: Optional[str] = None,
                 client_certificate_data: Optional[str] = None,
                 client_key_data: Optional[str] = None,
                 expires_at: Optional[str] = None,
                 server: Optional[str] = None,
                 token: Optional[str] = None):
        """
        :param str certificate_authority_data: A base64 encoding of bytes representing the certificate authority data for accessing the cluster.
        :param str client_certificate_data: A base64 encoding of bytes representing the x509 client
               certificate data for access the cluster. This is only returned for clusters
               without support for token-based authentication.
               
               Newly created Kubernetes clusters do not return credentials using
               certificate-based authentication. For additional information,
               [see here](https://www.digitalocean.com/docs/kubernetes/how-to/connect-to-cluster/#authenticate).
        :param str client_key_data: A base64 encoding of bytes representing the x509 client key
               data for access the cluster. This is only returned for clusters without
               support for token-based authentication.
               
               Newly created Kubernetes clusters do not return credentials using
               certificate-based authentication. For additional information,
               [see here](https://www.digitalocean.com/docs/kubernetes/how-to/connect-to-cluster/#authenticate).
        :param str expires_at: A time value given in ISO8601 combined date and time format that represents when the access token expires.
        :param str server: The URL used to access the cluster API server.
        :param str token: An access token used to authenticate with the cluster. This is only returned for clusters with support for token-based authentication.
        """
        if certificate_authority_data is not None:
            pulumi.set(__self__, "certificate_authority_data", certificate_authority_data)
        if client_certificate_data is not None:
            pulumi.set(__self__, "client_certificate_data", client_certificate_data)
        if client_key_data is not None:
            pulumi.set(__self__, "client_key_data", client_key_data)
        if expires_at is not None:
            pulumi.set(__self__, "expires_at", expires_at)
        if server is not None:
            pulumi.set(__self__, "server", server)
        if token is not None:
            pulumi.set(__self__, "token", token)

    @property
    @pulumi.getter(name="certificateAuthorityData")
    def certificate_authority_data(self) -> Optional[str]:
        """
        A base64 encoding of bytes representing the certificate authority data for accessing the cluster.
        """
        return pulumi.get(self, "certificate_authority_data")

    @property
    @pulumi.getter(name="clientCertificateData")
    def client_certificate_data(self) -> Optional[str]:
        """
        A base64 encoding of bytes representing the x509 client
        certificate data for access the cluster. This is only returned for clusters
        without support for token-based authentication.

        Newly created Kubernetes clusters do not return credentials using
        certificate-based authentication. For additional information,
        [see here](https://www.digitalocean.com/docs/kubernetes/how-to/connect-to-cluster/#authenticate).
        """
        return pulumi.get(self, "client_certificate_data")

    @property
    @pulumi.getter(name="clientKeyData")
    def client_key_data(self) -> Optional[str]:
        """
        A base64 encoding of bytes representing the x509 client key
        data for access the cluster. This is only returned for clusters without
        support for token-based authentication.

        Newly created Kubernetes clusters do not return credentials using
        certificate-based authentication. For additional information,
        [see here](https://www.digitalocean.com/docs/kubernetes/how-to/connect-to-cluster/#authenticate).
        """
        return pulumi.get(self, "client_key_data")

    @property
    @pulumi.getter(name="expiresAt")
    def expires_at(self) -> Optional[str]:
        """
        A time value given in ISO8601 combined date and time format that represents when the access token expires.
        """
        return pulumi.get(self, "expires_at")

    @property
    @pulumi.getter
    def server(self) -> Optional[str]:
        """
        The URL used to access the cluster API server.
        """
        return pulumi.get(self, "server")

    @property
    @pulumi.getter
    def token(self) -> Optional[str]:
        """
        An access token used to authenticate with the cluster. This is only returned for clusters with support for token-based authentication.
        """
        return pulumi.get(self, "token")


@pulumi.output_type
class GetKubernetesAvailableUpgradeProperties(dict):
    def __init__(__self__, *,
                 available_upgrade_versions: Optional[Sequence['outputs.KubernetesVersion']] = None):
        if available_upgrade_versions is not None:
            pulumi.set(__self__, "available_upgrade_versions", available_upgrade_versions)

    @property
    @pulumi.getter(name="availableUpgradeVersions")
    def available_upgrade_versions(self) -> Optional[Sequence['outputs.KubernetesVersion']]:
        return pulumi.get(self, "available_upgrade_versions")


@pulumi.output_type
class GetKubernetesClusterProperties(dict):
    def __init__(__self__, *,
                 kubernetes_cluster: Optional['outputs.Cluster'] = None):
        if kubernetes_cluster is not None:
            pulumi.set(__self__, "kubernetes_cluster", kubernetes_cluster)

    @property
    @pulumi.getter(name="kubernetesCluster")
    def kubernetes_cluster(self) -> Optional['outputs.Cluster']:
        return pulumi.get(self, "kubernetes_cluster")


@pulumi.output_type
class GetKubernetesNodePoolProperties(dict):
    def __init__(__self__, *,
                 node_pool: Optional['outputs.KubernetesNodePool'] = None):
        if node_pool is not None:
            pulumi.set(__self__, "node_pool", node_pool)

    @property
    @pulumi.getter(name="nodePool")
    def node_pool(self) -> Optional['outputs.KubernetesNodePool']:
        return pulumi.get(self, "node_pool")


@pulumi.output_type
class KubernetesNodePool(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "autoScale":
            suggest = "auto_scale"
        elif key == "maxNodes":
            suggest = "max_nodes"
        elif key == "minNodes":
            suggest = "min_nodes"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in KubernetesNodePool. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        KubernetesNodePool.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        KubernetesNodePool.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 auto_scale: Optional[bool] = None,
                 count: Optional[int] = None,
                 id: Optional[str] = None,
                 labels: Optional[Any] = None,
                 max_nodes: Optional[int] = None,
                 min_nodes: Optional[int] = None,
                 name: Optional[str] = None,
                 nodes: Optional[Sequence['outputs.Node']] = None,
                 size: Optional[str] = None,
                 tags: Optional[Sequence[str]] = None,
                 taints: Optional[Sequence['outputs.KubernetesNodePoolTaint']] = None):
        """
        :param bool auto_scale: A boolean value indicating whether auto-scaling is enabled for this node pool.
        :param int count: The number of Droplet instances in the node pool.
        :param str id: A unique ID that can be used to identify and reference a specific node pool.
        :param Any labels: An object of key/value mappings specifying labels to apply to all nodes in a pool. Labels will automatically be applied to all existing nodes and any subsequent nodes added to the pool. Note that when a label is removed, it is not deleted from the nodes in the pool.
        :param int max_nodes: The maximum number of nodes that this node pool can be auto-scaled to. The value will be `0` if `auto_scale` is set to `false`.
        :param int min_nodes: The minimum number of nodes that this node pool can be auto-scaled to. The value will be `0` if `auto_scale` is set to `false`.
        :param str name: A human-readable name for the node pool.
        :param Sequence['Node'] nodes: An object specifying the details of a specific worker node in a node pool.
        :param str size: The slug identifier for the type of Droplet used as workers in the node pool.
        :param Sequence[str] tags: An array containing the tags applied to the node pool. All node pools are automatically tagged `k8s`, `k8s-worker`, and `k8s:$K8S_CLUSTER_ID`.
        :param Sequence['KubernetesNodePoolTaint'] taints: An array of taints to apply to all nodes in a pool. Taints will automatically be applied to all existing nodes and any subsequent nodes added to the pool. When a taint is removed, it is deleted from all nodes in the pool.
        """
        if auto_scale is not None:
            pulumi.set(__self__, "auto_scale", auto_scale)
        if count is not None:
            pulumi.set(__self__, "count", count)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if max_nodes is not None:
            pulumi.set(__self__, "max_nodes", max_nodes)
        if min_nodes is not None:
            pulumi.set(__self__, "min_nodes", min_nodes)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if nodes is not None:
            pulumi.set(__self__, "nodes", nodes)
        if size is not None:
            pulumi.set(__self__, "size", size)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if taints is not None:
            pulumi.set(__self__, "taints", taints)

    @property
    @pulumi.getter(name="autoScale")
    def auto_scale(self) -> Optional[bool]:
        """
        A boolean value indicating whether auto-scaling is enabled for this node pool.
        """
        return pulumi.get(self, "auto_scale")

    @property
    @pulumi.getter
    def count(self) -> Optional[int]:
        """
        The number of Droplet instances in the node pool.
        """
        return pulumi.get(self, "count")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        A unique ID that can be used to identify and reference a specific node pool.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def labels(self) -> Optional[Any]:
        """
        An object of key/value mappings specifying labels to apply to all nodes in a pool. Labels will automatically be applied to all existing nodes and any subsequent nodes added to the pool. Note that when a label is removed, it is not deleted from the nodes in the pool.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter(name="maxNodes")
    def max_nodes(self) -> Optional[int]:
        """
        The maximum number of nodes that this node pool can be auto-scaled to. The value will be `0` if `auto_scale` is set to `false`.
        """
        return pulumi.get(self, "max_nodes")

    @property
    @pulumi.getter(name="minNodes")
    def min_nodes(self) -> Optional[int]:
        """
        The minimum number of nodes that this node pool can be auto-scaled to. The value will be `0` if `auto_scale` is set to `false`.
        """
        return pulumi.get(self, "min_nodes")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        A human-readable name for the node pool.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def nodes(self) -> Optional[Sequence['outputs.Node']]:
        """
        An object specifying the details of a specific worker node in a node pool.
        """
        return pulumi.get(self, "nodes")

    @property
    @pulumi.getter
    def size(self) -> Optional[str]:
        """
        The slug identifier for the type of Droplet used as workers in the node pool.
        """
        return pulumi.get(self, "size")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Sequence[str]]:
        """
        An array containing the tags applied to the node pool. All node pools are automatically tagged `k8s`, `k8s-worker`, and `k8s:$K8S_CLUSTER_ID`.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def taints(self) -> Optional[Sequence['outputs.KubernetesNodePoolTaint']]:
        """
        An array of taints to apply to all nodes in a pool. Taints will automatically be applied to all existing nodes and any subsequent nodes added to the pool. When a taint is removed, it is deleted from all nodes in the pool.
        """
        return pulumi.get(self, "taints")


@pulumi.output_type
class KubernetesNodePoolTaint(dict):
    def __init__(__self__, *,
                 effect: Optional['KubernetesNodePoolTaintEffect'] = None,
                 key: Optional[str] = None,
                 value: Optional[str] = None):
        """
        :param 'KubernetesNodePoolTaintEffect' effect: How the node reacts to pods that it won't tolerate. Available effect values are `NoSchedule`, `PreferNoSchedule`, and `NoExecute`.
        :param str key: An arbitrary string. The `key` and `value` fields of the `taint` object form a key-value pair. For example, if the value of the `key` field is "special" and the value of the `value` field is "gpu", the key value pair would be `special=gpu`.
        :param str value: An arbitrary string. The `key` and `value` fields of the `taint` object form a key-value pair. For example, if the value of the `key` field is "special" and the value of the `value` field is "gpu", the key value pair would be `special=gpu`.
        """
        if effect is not None:
            pulumi.set(__self__, "effect", effect)
        if key is not None:
            pulumi.set(__self__, "key", key)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def effect(self) -> Optional['KubernetesNodePoolTaintEffect']:
        """
        How the node reacts to pods that it won't tolerate. Available effect values are `NoSchedule`, `PreferNoSchedule`, and `NoExecute`.
        """
        return pulumi.get(self, "effect")

    @property
    @pulumi.getter
    def key(self) -> Optional[str]:
        """
        An arbitrary string. The `key` and `value` fields of the `taint` object form a key-value pair. For example, if the value of the `key` field is "special" and the value of the `value` field is "gpu", the key value pair would be `special=gpu`.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> Optional[str]:
        """
        An arbitrary string. The `key` and `value` fields of the `taint` object form a key-value pair. For example, if the value of the `key` field is "special" and the value of the `value` field is "gpu", the key value pair would be `special=gpu`.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class KubernetesOptions(dict):
    def __init__(__self__, *,
                 options: Optional['outputs.KubernetesOptionsOptionsProperties'] = None):
        if options is not None:
            pulumi.set(__self__, "options", options)

    @property
    @pulumi.getter
    def options(self) -> Optional['outputs.KubernetesOptionsOptionsProperties']:
        return pulumi.get(self, "options")


@pulumi.output_type
class KubernetesOptionsOptionsProperties(dict):
    def __init__(__self__, *,
                 regions: Optional[Sequence['outputs.KubernetesRegion']] = None,
                 sizes: Optional[Sequence['outputs.KubernetesSize']] = None,
                 versions: Optional[Sequence['outputs.KubernetesVersion']] = None):
        if regions is not None:
            pulumi.set(__self__, "regions", regions)
        if sizes is not None:
            pulumi.set(__self__, "sizes", sizes)
        if versions is not None:
            pulumi.set(__self__, "versions", versions)

    @property
    @pulumi.getter
    def regions(self) -> Optional[Sequence['outputs.KubernetesRegion']]:
        return pulumi.get(self, "regions")

    @property
    @pulumi.getter
    def sizes(self) -> Optional[Sequence['outputs.KubernetesSize']]:
        return pulumi.get(self, "sizes")

    @property
    @pulumi.getter
    def versions(self) -> Optional[Sequence['outputs.KubernetesVersion']]:
        return pulumi.get(self, "versions")


@pulumi.output_type
class KubernetesRegion(dict):
    def __init__(__self__, *,
                 name: Optional[str] = None,
                 slug: Optional[str] = None):
        """
        :param str name: A DigitalOcean region where Kubernetes is available.
        :param str slug: The identifier for a region for use when creating a new cluster.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if slug is not None:
            pulumi.set(__self__, "slug", slug)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        A DigitalOcean region where Kubernetes is available.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def slug(self) -> Optional[str]:
        """
        The identifier for a region for use when creating a new cluster.
        """
        return pulumi.get(self, "slug")


@pulumi.output_type
class KubernetesSize(dict):
    def __init__(__self__, *,
                 name: Optional[str] = None,
                 slug: Optional[str] = None):
        """
        :param str name: A Droplet size available for use in a Kubernetes node pool.
        :param str slug: The identifier for a size for use when creating a new cluster.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if slug is not None:
            pulumi.set(__self__, "slug", slug)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        A Droplet size available for use in a Kubernetes node pool.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def slug(self) -> Optional[str]:
        """
        The identifier for a size for use when creating a new cluster.
        """
        return pulumi.get(self, "slug")


@pulumi.output_type
class KubernetesVersion(dict):
    def __init__(__self__, *,
                 kubernetes_version: Optional[str] = None,
                 slug: Optional[str] = None,
                 supported_features: Optional[Sequence[str]] = None):
        """
        :param str kubernetes_version: The upstream version string for the version of Kubernetes provided by a given slug.
        :param str slug: The slug identifier for an available version of Kubernetes for use when creating or updating a cluster. The string contains both the upstream version of Kubernetes as well as the DigitalOcean revision.
        :param Sequence[str] supported_features: The features available with the version of Kubernetes provided by a given slug.
        """
        if kubernetes_version is not None:
            pulumi.set(__self__, "kubernetes_version", kubernetes_version)
        if slug is not None:
            pulumi.set(__self__, "slug", slug)
        if supported_features is not None:
            pulumi.set(__self__, "supported_features", supported_features)

    @property
    @pulumi.getter(name="kubernetesVersion")
    def kubernetes_version(self) -> Optional[str]:
        """
        The upstream version string for the version of Kubernetes provided by a given slug.
        """
        return pulumi.get(self, "kubernetes_version")

    @property
    @pulumi.getter
    def slug(self) -> Optional[str]:
        """
        The slug identifier for an available version of Kubernetes for use when creating or updating a cluster. The string contains both the upstream version of Kubernetes as well as the DigitalOcean revision.
        """
        return pulumi.get(self, "slug")

    @property
    @pulumi.getter(name="supportedFeatures")
    def supported_features(self) -> Optional[Sequence[str]]:
        """
        The features available with the version of Kubernetes provided by a given slug.
        """
        return pulumi.get(self, "supported_features")


@pulumi.output_type
class ListKubernetesClustersItems(dict):
    def __init__(__self__, *,
                 meta: 'outputs.MetaMeta',
                 kubernetes_clusters: Optional[Sequence['outputs.Cluster']] = None,
                 links: Optional['outputs.PageLinks'] = None):
        pulumi.set(__self__, "meta", meta)
        if kubernetes_clusters is not None:
            pulumi.set(__self__, "kubernetes_clusters", kubernetes_clusters)
        if links is not None:
            pulumi.set(__self__, "links", links)

    @property
    @pulumi.getter
    def meta(self) -> 'outputs.MetaMeta':
        return pulumi.get(self, "meta")

    @property
    @pulumi.getter(name="kubernetesClusters")
    def kubernetes_clusters(self) -> Optional[Sequence['outputs.Cluster']]:
        return pulumi.get(self, "kubernetes_clusters")

    @property
    @pulumi.getter
    def links(self) -> Optional['outputs.PageLinks']:
        return pulumi.get(self, "links")


@pulumi.output_type
class ListKubernetesNodePoolsProperties(dict):
    def __init__(__self__, *,
                 node_pools: Optional[Sequence['outputs.KubernetesNodePool']] = None):
        if node_pools is not None:
            pulumi.set(__self__, "node_pools", node_pools)

    @property
    @pulumi.getter(name="nodePools")
    def node_pools(self) -> Optional[Sequence['outputs.KubernetesNodePool']]:
        return pulumi.get(self, "node_pools")


@pulumi.output_type
class MaintenancePolicy(dict):
    """
    An object specifying the maintenance window policy for the Kubernetes cluster.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "startTime":
            suggest = "start_time"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MaintenancePolicy. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MaintenancePolicy.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MaintenancePolicy.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 day: Optional['MaintenancePolicyDay'] = None,
                 duration: Optional[str] = None,
                 start_time: Optional[str] = None):
        """
        An object specifying the maintenance window policy for the Kubernetes cluster.
        :param 'MaintenancePolicyDay' day: The day of the maintenance window policy. May be one of `monday` through `sunday`, or `any` to indicate an arbitrary week day.
        :param str duration: The duration of the maintenance window policy in human-readable format.
        :param str start_time: The start time in UTC of the maintenance window policy in 24-hour clock format / HH:MM notation (e.g., `15:00`).
        """
        if day is not None:
            pulumi.set(__self__, "day", day)
        if duration is not None:
            pulumi.set(__self__, "duration", duration)
        if start_time is not None:
            pulumi.set(__self__, "start_time", start_time)

    @property
    @pulumi.getter
    def day(self) -> Optional['MaintenancePolicyDay']:
        """
        The day of the maintenance window policy. May be one of `monday` through `sunday`, or `any` to indicate an arbitrary week day.
        """
        return pulumi.get(self, "day")

    @property
    @pulumi.getter
    def duration(self) -> Optional[str]:
        """
        The duration of the maintenance window policy in human-readable format.
        """
        return pulumi.get(self, "duration")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> Optional[str]:
        """
        The start time in UTC of the maintenance window policy in 24-hour clock format / HH:MM notation (e.g., `15:00`).
        """
        return pulumi.get(self, "start_time")


@pulumi.output_type
class MetaMeta(dict):
    def __init__(__self__, *,
                 total: Optional[int] = None):
        """
        :param int total: Number of objects returned by the request.
        """
        if total is not None:
            pulumi.set(__self__, "total", total)

    @property
    @pulumi.getter
    def total(self) -> Optional[int]:
        """
        Number of objects returned by the request.
        """
        return pulumi.get(self, "total")


@pulumi.output_type
class Node(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "dropletId":
            suggest = "droplet_id"
        elif key == "updatedAt":
            suggest = "updated_at"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in Node. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        Node.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        Node.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 droplet_id: Optional[str] = None,
                 id: Optional[str] = None,
                 name: Optional[str] = None,
                 status: Optional['outputs.NodeStatusProperties'] = None,
                 updated_at: Optional[str] = None):
        """
        :param str created_at: A time value given in ISO8601 combined date and time format that represents when the node was created.
        :param str droplet_id: The ID of the Droplet used for the worker node.
        :param str id: A unique ID that can be used to identify and reference the node.
        :param str name: An automatically generated, human-readable name for the node.
        :param 'NodeStatusProperties' status: An object containing a `state` attribute whose value is set to a string indicating the current status of the node.
        :param str updated_at: A time value given in ISO8601 combined date and time format that represents when the node was last updated.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if droplet_id is not None:
            pulumi.set(__self__, "droplet_id", droplet_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        A time value given in ISO8601 combined date and time format that represents when the node was created.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="dropletId")
    def droplet_id(self) -> Optional[str]:
        """
        The ID of the Droplet used for the worker node.
        """
        return pulumi.get(self, "droplet_id")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        A unique ID that can be used to identify and reference the node.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        An automatically generated, human-readable name for the node.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def status(self) -> Optional['outputs.NodeStatusProperties']:
        """
        An object containing a `state` attribute whose value is set to a string indicating the current status of the node.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[str]:
        """
        A time value given in ISO8601 combined date and time format that represents when the node was last updated.
        """
        return pulumi.get(self, "updated_at")


@pulumi.output_type
class NodeStatusProperties(dict):
    """
    An object containing a `state` attribute whose value is set to a string indicating the current status of the node.
    """
    def __init__(__self__, *,
                 state: Optional['NodeStatusPropertiesState'] = None):
        """
        An object containing a `state` attribute whose value is set to a string indicating the current status of the node.
        :param 'NodeStatusPropertiesState' state: A string indicating the current status of the node.
        """
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter
    def state(self) -> Optional['NodeStatusPropertiesState']:
        """
        A string indicating the current status of the node.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class PageLinks(dict):
    def __init__(__self__, *,
                 pages: Optional['outputs.PageLinksPagesProperties'] = None):
        if pages is not None:
            pulumi.set(__self__, "pages", pages)

    @property
    @pulumi.getter
    def pages(self) -> Optional['outputs.PageLinksPagesProperties']:
        return pulumi.get(self, "pages")


@pulumi.output_type
class PageLinksPagesProperties(dict):
    def __init__(__self__, *,
                 first: Optional[str] = None,
                 last: Optional[str] = None,
                 next: Optional[str] = None,
                 prev: Optional[str] = None):
        if first is not None:
            pulumi.set(__self__, "first", first)
        if last is not None:
            pulumi.set(__self__, "last", last)
        if next is not None:
            pulumi.set(__self__, "next", next)
        if prev is not None:
            pulumi.set(__self__, "prev", prev)

    @property
    @pulumi.getter
    def first(self) -> Optional[str]:
        return pulumi.get(self, "first")

    @property
    @pulumi.getter
    def last(self) -> Optional[str]:
        return pulumi.get(self, "last")

    @property
    @pulumi.getter
    def next(self) -> Optional[str]:
        return pulumi.get(self, "next")

    @property
    @pulumi.getter
    def prev(self) -> Optional[str]:
        return pulumi.get(self, "prev")


@pulumi.output_type
class StatusProperties(dict):
    """
    An object containing a `state` attribute whose value is set to a string indicating the current status of the cluster.
    """
    def __init__(__self__, *,
                 message: Optional[str] = None,
                 state: Optional['StatusPropertiesState'] = None):
        """
        An object containing a `state` attribute whose value is set to a string indicating the current status of the cluster.
        :param str message: An optional message providing additional information about the current cluster state.
        :param 'StatusPropertiesState' state: A string indicating the current status of the cluster.
        """
        if message is not None:
            pulumi.set(__self__, "message", message)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter
    def message(self) -> Optional[str]:
        """
        An optional message providing additional information about the current cluster state.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter
    def state(self) -> Optional['StatusPropertiesState']:
        """
        A string indicating the current status of the cluster.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class User(dict):
    def __init__(__self__, *,
                 kubernetes_cluster_user: Optional['outputs.UserKubernetesClusterUserProperties'] = None):
        if kubernetes_cluster_user is not None:
            pulumi.set(__self__, "kubernetes_cluster_user", kubernetes_cluster_user)

    @property
    @pulumi.getter(name="kubernetesClusterUser")
    def kubernetes_cluster_user(self) -> Optional['outputs.UserKubernetesClusterUserProperties']:
        return pulumi.get(self, "kubernetes_cluster_user")


@pulumi.output_type
class UserKubernetesClusterUserProperties(dict):
    def __init__(__self__, *,
                 groups: Optional[Sequence[str]] = None,
                 username: Optional[str] = None):
        """
        :param Sequence[str] groups: A list of in-cluster groups that the user belongs to.
        :param str username: The username for the cluster admin user.
        """
        if groups is not None:
            pulumi.set(__self__, "groups", groups)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter
    def groups(self) -> Optional[Sequence[str]]:
        """
        A list of in-cluster groups that the user belongs to.
        """
        return pulumi.get(self, "groups")

    @property
    @pulumi.getter
    def username(self) -> Optional[str]:
        """
        The username for the cluster admin user.
        """
        return pulumi.get(self, "username")


