# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['TagsAssignResourceArgs', 'TagsAssignResource']

@pulumi.input_type
class TagsAssignResourceArgs:
    def __init__(__self__, *,
                 resources: pulumi.Input[Sequence[pulumi.Input['ResourcesItemPropertiesArgs']]],
                 tag_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a TagsAssignResource resource.
        :param pulumi.Input[Sequence[pulumi.Input['ResourcesItemPropertiesArgs']]] resources: An array of objects containing resource_id and resource_type  attributes.
        :param pulumi.Input[str] tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and underscores. There is a limit of 255 characters per tag.
        """
        pulumi.set(__self__, "resources", resources)
        if tag_id is not None:
            pulumi.set(__self__, "tag_id", tag_id)

    @property
    @pulumi.getter
    def resources(self) -> pulumi.Input[Sequence[pulumi.Input['ResourcesItemPropertiesArgs']]]:
        """
        An array of objects containing resource_id and resource_type  attributes.
        """
        return pulumi.get(self, "resources")

    @resources.setter
    def resources(self, value: pulumi.Input[Sequence[pulumi.Input['ResourcesItemPropertiesArgs']]]):
        pulumi.set(self, "resources", value)

    @property
    @pulumi.getter(name="tagId")
    def tag_id(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the tag. Tags may contain letters, numbers, colons, dashes, and underscores. There is a limit of 255 characters per tag.
        """
        return pulumi.get(self, "tag_id")

    @tag_id.setter
    def tag_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tag_id", value)


class TagsAssignResource(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 resources: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ResourcesItemPropertiesArgs', 'ResourcesItemPropertiesArgsDict']]]]] = None,
                 tag_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a TagsAssignResource resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ResourcesItemPropertiesArgs', 'ResourcesItemPropertiesArgsDict']]]] resources: An array of objects containing resource_id and resource_type  attributes.
        :param pulumi.Input[str] tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and underscores. There is a limit of 255 characters per tag.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TagsAssignResourceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a TagsAssignResource resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param TagsAssignResourceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TagsAssignResourceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 resources: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ResourcesItemPropertiesArgs', 'ResourcesItemPropertiesArgsDict']]]]] = None,
                 tag_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TagsAssignResourceArgs.__new__(TagsAssignResourceArgs)

            if resources is None and not opts.urn:
                raise TypeError("Missing required property 'resources'")
            __props__.__dict__["resources"] = resources
            __props__.__dict__["tag_id"] = tag_id
        super(TagsAssignResource, __self__).__init__(
            'digitalocean-native:tags/v2:TagsAssignResource',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'TagsAssignResource':
        """
        Get an existing TagsAssignResource resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = TagsAssignResourceArgs.__new__(TagsAssignResourceArgs)

        __props__.__dict__["resources"] = None
        return TagsAssignResource(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def resources(self) -> pulumi.Output[Sequence['outputs.ResourcesItemProperties']]:
        """
        An array of objects containing resource_id and resource_type  attributes.
        """
        return pulumi.get(self, "resources")

